create proc tsqlt.Private_Cleanup_SpyProcedureLog
as
begin tran

declare @sql varchar(max) = 'BEGIN TRAN
BEGIN TRY
'
select @sql = @sql + 'DROP ' + replace(TABLE_TYPE, 'BASE ', '') + ' ' + [TABLE_NAME] + ';
' from INFORMATION_SCHEMA.TABLES where TABLE_NAME like '%__SpyProcedureLog' and TABLE_TYPE = 'BASE TABLE'
select @sql = @sql + '
	print ''EXEC tsqlt.Private_Cleanup_SpyProcedureLog'';
END TRY
BEGIN CATCH
	IF @@TRANCOUNT > 0 ROLLBACK;	
END CATCH;
IF @@TRANCOUNT > 0	COMMIT;
'
print @sql;
--EXEC (@sql);
EXEC tSQLt.SuppressOutput @sql

commit

return
GO