create proc tsqlt.Private_Cleanup_tSQLt_tempobject
as
begin tran

declare @sql varchar(max) = 'BEGIN TRAN
BEGIN TRY
'
select @sql = @sql + 'DROP ' + replace(TABLE_TYPE, 'BASE ', '') + ' ' + [TABLE_NAME] + ';
' from INFORMATION_SCHEMA.TABLES where TABLE_NAME like 'tSQLt_tempobject_%' --TABLE_TYPE = 'BASE TABLE'
select @sql = @sql + 'DROP ' + ROUTINE_TYPE + ' ' + [ROUTINE_NAME] + ';
' from INFORMATION_SCHEMA.ROUTINES where ROUTINE_NAME like 'tSQLt_tempobject_%'  --and ROUTINE_TYPE = 'PROCEDURE'
select @sql = @sql + '
	print ''EXEC tsqlt.Private_Cleanup_tSQLt_tempobject'';
END TRY
BEGIN CATCH
	IF @@TRANCOUNT > 0 ROLLBACK;	
END CATCH;
IF @@TRANCOUNT > 0	COMMIT;
'
print @sql;
--EXEC (@sql);
EXEC tSQLt.SuppressOutput @sql

commit

return
GO